from cloud_resources.sentry_client import sentry_client


class BaseException(Exception):
    message = "Some error has occured in the AWS resource configuration"

    def __init__(self, message=None):
        Exception.__init__(self)
        if message:
            self.message = 'Cloud Resource: ' + message
        sentry_client.log_error(self.message)
        sentry_client.logall_debug_queue()

    def __str__(self):
        return self.message


class S3OperationError(BaseException):
    message = 'Cloud Resource: S3 error has occured'

    def __init__(self, message=None):
        if message:
            self.message = 'Cloud Resource: ' + message


class SQSError(BaseException):
    message = 'Cloud Resource: SQS Error has occured'

    def __init__(self, message=None):
        if message:
            self.message = 'Cloud Resource: ' + message


class SigningError(BaseException):
    message = 'Cloud Resource: CFront Error has occured'

    def __init__(self, message=None):
        if message:
            self.message = 'Cloud Resource: ' + message


class ClusterError(BaseException):
    message = 'Cloud Resource: Cluster Error has occured'

    def __init__(self, message=None):
        if message:
            self.message = 'Cloud Resource: ' + message

class InvalidInputError(BaseException):
    message = 'Cloud Resource: Invalid Input Error'

    def __init__(self, message=None):
        if message:
            self.message = 'Cloud Resource: ' + message
